Package org.apache.bcel.util

# Class MemorySensitiveClassPathRepository

java.lang.Object
org.apache.bcel.util.MemorySensitiveClassPathRepository

All Implemented Interfaces:
  `Repository`

Direct Known Subclasses:
  `SyntheticRepository`

public class MemorySensitiveClassPathRepository extends Object
This repository is used in situations where a Class is created outside the realm of a ClassLoader. Classes are loaded from the file systems using the paths specified in the given class path. By default, this is the value returned by ClassPath.getClassPath(). This repository holds onto classes with SoftReferences, and will reload as needed, in cases where memory sizes are important.

See Also:
  - `Repository`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MemorySensitiveClassPathRepository(ClassPath path)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Clear all entries from cache.
  `JavaClass`
  `findClass(String className)`
  Find an already defined (cached) JavaClass object by name.
  `ClassPath`
  `getClassPath()`
  Gets the ClassPath associated with this Repository
  `JavaClass`
  `loadClass(Class<?> clazz)`
  Finds the JavaClass object for a runtime Class object.
  `JavaClass`
  `loadClass(String className)`
  Finds a JavaClass object by name.
  `void`
  `removeClass(JavaClass clazz)`
  Remove class from repository
  `void`
  `storeClass(JavaClass clazz)`
  Store a new JavaClass instance into this Repository.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MemorySensitiveClassPathRepository

    public MemorySensitiveClassPathRepository(ClassPath path)

- ## Method Details

  - ### clear

    public void clear()
    Clear all entries from cache.
    Specified by:
      `clear` in interface `Repository`

  - ### findClass

    public JavaClass findClass(String className)
    Find an already defined (cached) JavaClass object by name.
    Specified by:
      `findClass` in interface `Repository`

  - ### removeClass

    public void removeClass(JavaClass clazz)
    Remove class from repository
    Specified by:
      `removeClass` in interface `Repository`

  - ### storeClass

    public void storeClass(JavaClass clazz)
    Store a new JavaClass instance into this Repository.
    Specified by:
      `storeClass` in interface `Repository`

  - ### getClassPath

    public ClassPath getClassPath()
    Description copied from interface: `Repository`
    Gets the ClassPath associated with this Repository
    Specified by:
      `getClassPath` in interface `Repository`

  - ### loadClass

    public JavaClass loadClass(Class<?> clazz) throws ClassNotFoundException
    Finds the JavaClass object for a runtime Class object. If a class with the same name is already in this Repository, the Repository version is returned. Otherwise, getResourceAsStream() is called on the Class object to find the class's representation. If the representation is found, it is added to the Repository.
    Specified by:
      `loadClass` in interface `Repository`
    Parameters:
      `clazz` - the runtime Class object
    Returns:
      JavaClass object for given runtime class
    Throws:
      `ClassNotFoundException` - if the class is not in the Repository, and its representation could not be found
    See Also:
      - `Class`

  - ### loadClass

    public JavaClass loadClass(String className) throws ClassNotFoundException
    Finds a JavaClass object by name. If it is already in this Repository, the Repository version is returned. Otherwise, the Repository's classpath is searched for the class (and it is added to the Repository if found).
    Specified by:
      `loadClass` in interface `Repository`
    Parameters:
      `className` - the name of the class
    Returns:
      the JavaClass object
    Throws:
      `ClassNotFoundException` - if the class is not in the Repository, and could not be found on the classpath